//
//  ExpanderControl.m
//  RARExpander
//
//  Created by KO on 11-3-30.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ExpanderControl.h"
#import "ExpanderItem.h"
#import "mainView.h"
#import "ExpanderProcess.h"
#import "Constants.h"

	//static ExpanderControl * theSharedController = nil;

@implementation ExpanderControl

-(void)setPasswordError:(NSInteger)num
{
	[item setPasswordError:num];
}

-(NSInteger)passwordError
{
	return [item passwordError];
}

-(void)setControlernum:(NSInteger)num
{
	[item setControlernum:num];
}

-(NSInteger)controllerNum
{
	return [item controllerNum];
}

-(void)setBadAchive:(NSInteger)num
{
	[item setBadAchive:num];
}

-(void)setOneWindowControl:(NSInteger)num
{
	[item setOneWindowControl:num];
}

-(NSInteger)oneWindowControl
{
	return [item oneWindowControl];
}

-(void)setWaitWindow:(NSInteger)num
{
	[item setWaitWindow:num];
}

-(NSInteger)waitWindow
{
	return [item waitWindow];
}


/*- (NSString *) askPassword
{
	NSString * password;
	
	password = [self askPasswordFor];
	
	
	return password;
}*/

/*- (ExpanderControl *) init
{
	[super init];
	theSharedController   = self;
	return self;
}*/

-(void)runWindow
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
		//[NSApp runModalForWindow:[self passwordWindow]];
	[self passwordWindow];
	[pool release];
}

-(void)runPasswordWindow
{
		//[NSApp runModalForWindow:[self passwordWindow]];
		//[NSApp runModalForWindow:passwordwindow];
		[NSThread detachNewThreadSelector:@selector(runWindow) toTarget:self withObject:nil];
	
}

/*- (NSString *) askPasswordFor
{
	[self setValue: nil forKey: @"passwords"];
		//if([[NSApplication sharedApplication] runModalForWindow: passwordwindow] == NSRunStoppedResponse)
	[passwordwindow makeKeyAndOrderFront:self];
		NSLog(@"password = %@",passwords);
		return passwords;
}*/



/*- (NSString *) askPasswordFor: (ExpanderProcess *) expansionProcess
{
	[self setValue: nil forKey: @"passwords"];
	if([[NSApplication sharedApplication] runModalForWindow: passwordwindow] == NSRunStoppedResponse)
		return passwords;
}*/

/*+ (ExpanderControl *) sharedController
{
	return theSharedController;
}*/


- (void)loadUIFromNib {
	
	if ([NSBundle loadNibNamed:@"ExpanderItem" owner:self]==NO)  {
		
		NSLog(@"error");
		
	}
}

- (void)loadUIFromNib1 {
	
	if ([NSBundle loadNibNamed:@"passwordWindow" owner:self]==NO)  {
		
		NSLog(@"error");
		
	}
}

- (NSView *)rootView {
	
    if (_rootview == nil) 
		
		[self loadUIFromNib];
	
    return _rootview;
	
}

- (IBAction)onBtnStopClick:(id)sender{
	
	[item setCancleData:-1];
		
}

-(void)setData:(NSInteger)number
{
	[item setData:number];
}

-(NSInteger)getData
{
	NSInteger number = [item Data];
	
	return number;
}

- (ExpanderItem *)item{
	
	return item;
}
- (void)setItem:(ExpanderItem *)newAsset{
		
	if (item != newAsset) {
		
        id old = item;
		
        item = [newAsset retain];
		
        [old release];
		
	}
}

-(void)setProgress
{
	[NSThread detachNewThreadSelector:@selector(startProgress) toTarget:self withObject:nil];
}

-(float)getProgress
{
	float i =[item Progress];
		
	return i;
}

-(void)startProgress
{
			
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	[progress setDoubleValue:0.0f];
	
	[progress displayIfNeeded];
	
	/*if ([item ProgressData] == 1) {
		
		[progress setIndeterminate:YES];
		
		[progress setUsesThreadedAnimation:YES];
		
		[progress startAnimation:self];
		}*/
	
		//else {
		[progress setIndeterminate:NO];
		
		[progress setStyle:NSProgressIndicatorBarStyle];
		
		[progress setMaxValue:100.0];
		
		[progress setMinValue:0.0];
		
		[progress setUsesThreadedAnimation:YES];
		
		do
		{
			float i =[item Progress];
			
			[progress setDoubleValue:i];
			
		}while ([progress doubleValue] != 100);
		
		//}

	[pool release];
	
}


-(void)setStates:(NSString*)state
{	
	NSString *str1 = [item showStates];
	
	NSString *str = [NSString stringWithFormat:@"%@ %@",str1,state];
	
	[item setStates:str];
	
}

-(NSString *)getStates
{
	NSString *string = [item showStates];
	
	return string;
}


-(NSString *)checkStates
{
	NSString *r = [self getStates];
	
	return r;
}

-(NSWindow *)passwordWindow;
{
		//passwordwindow == nil; 
	
	[self loadUIFromNib1];
	
	return passwordwindow;
 }

-(NSString *)passWords
{
	return passwords;
}

/*-(void)setControlernum:(NSInteger)num
{
	[item setControlernum:num];
}*/

/*-(NSString *)requestPassword
{
	[self setValue: nil forKey: @"password"];
	if([NSApp runModalForWindow:passwordwindow] != NSRunStoppedResponse)
	{
		[item setControlernum:1];
		
		[item setStates:@"Extract over"];
		
	}
	return password;
}*/

-(IBAction)surePassword:(id)sender
{
	
	[item setPasswords:[getpassword stringValue]];
		//NSLog(@"textfield = %@",[getpassword stringValue]);
	[self setWaitWindow:1];
	[passwordwindow orderOut:self];
		//[[NSApplication sharedApplication] stopModal];
}

-(IBAction)canclePassword:(id)sender;
{
	[item setControlernum:1];
	[passwordwindow orderOut:self];
		//[[NSApplication sharedApplication] abortModal];
}

@end
