//
//  ExpanderItem.h
//  RARExpander
//
//  Created by KO on 11-3-30.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "ExpanderProcess.h"
#import "ExpanderControl.h"
#include "dll.hpp"

/*@protocol ExpanderPublicProtocol
- (oneway void) startExpanding: (id<ExpansionProcessProtocol>) expansionProcess_;
	//-(oneway void) startExpanding:(ExpanderControl *) expansionProcess_;
@end*/

@interface ExpanderItem : NSObject {
	NSString*   fileanme;
	NSString*   filepath;
	float       nProgress;
	NSString*   states;
	NSInteger canclenum;
	NSString * password;
	NSInteger passwordcontoller;
	NSString* savepassd;
	NSInteger contorllornum;
	NSInteger windowsetnum;
	NSString* savefilename;
	NSInteger badachive;
	NSInteger extractresult;
	NSInteger controlcanclenum;
	NSInteger passworderror;
		//ExpanderControl*	expansionControl;
		//id				expansionProcess;
	ExpanderControl*			expansionProcess;

	unsigned long long totalSize;
	unsigned long long cursize;

}
-(void)setPasswordError:(NSInteger)num;

-(NSInteger)passwordError;

-(void)setBadAchive:(NSInteger)num;

-(NSInteger)badAchive;

-(void)setExtractResult:(NSInteger)num;

-(NSInteger)ExtractResult;

-(void)setSaveFilename:(NSString *)filename;

-(NSString *)saveFilename;

-(void)setOneWindowControl:(NSInteger)num;

-(NSInteger)oneWindowControl;

-(void)setWaitWindow:(NSInteger)num;

-(NSInteger)waitWindow;

-intWithFileName:(NSString*)filename;

	//-(void)setExpansionControl:(ExpanderControl*)control;

-(void)setCancleData:(NSInteger)data;

-(NSInteger)cancleData;

-(void)setPassWordContoller:(NSInteger)passnum;

-(NSInteger)passWordContoller;

-(void)setPasswords:(NSString *)pass;

	//-(void)setsavePassd:(char*)pass;

	//-(char*)savePassd;

-(void)setMyPassword:(NSString *)pass;

-(NSString*)passWord;

	//-(void)setProgressData:(NSInteger)num;

	//-(NSInteger)ProgressData;

-(void)setControlernum:(NSInteger)num;

-(NSInteger)controllerNum;

-(NSInteger)Data;

-(void)setData:(NSInteger)number;

-(NSString*)showStates;

-(void)setStates:(NSString*)state;

-(void)setFilePath:(NSString*)paths;

-(NSString*)Showname;

-(void)setShowname:(NSString*)value;

-(float)Progress;

-(void)setProgress:(float)value;

-(BOOL)expanderContent;

-(BOOL)expanderContentEx;

	//-(void)startExpander;
-(void)startExpander:(ExpanderControl *)control;

- (int) processOpenArchiveStatusCode: (int) statusCode handle: (HANDLE) archiveHandle;

-(int) handleProcessDataCallBack:  (unsigned char *) data  size: (int) size;

- (int) handleNeedPasswordCallBack: (char *) data size: (int) size;

-(struct RAROpenArchiveData) getOpenArchiveDataForMode: (int) mode;

@end
