//
//  ExpanderItem.m
//  RARExpander
//
//  Created by KO on 11-3-30.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//
#include <stdio.h>
#include <stdlib.h>
#include "dll.hpp"

#import "ExpanderItem.h"
#import "AppController.h"
#import "ExpanderControl.h"
#import "Constants.h"

int volumeChange(char * nextArchiveName, int mode) {
	if(mode = RAR_VOL_ASK) {
		fprintf(stderr, "Volume not found %s\n", nextArchiveName);
		return 0;
	} else {
		fprintf(stderr, "Next volume is %s\n", nextArchiveName);
		return 1;
	}
}
int processData(unsigned char *  data,  int size){
	NSLog(@"size = %d",size);
	return 1;
}

int handleRARCallBack(UINT msg, LONG UserData, LONG P1, LONG P2) {
	
	ExpanderItem * expander = (ExpanderItem *) UserData;
	
	switch (msg) {
			
		//case UCM_CHANGEVOLUME : return [expander handleVolumeSwitchCallBack: (char *) P1           mode: (int) P2];
		
		case UCM_NEEDPASSWORD :	return [expander handleNeedPasswordCallBack: (char *) P1           size: (int) P2];
		
		case UCM_PROCESSDATA  :	return [expander handleProcessDataCallBack:  (unsigned char *) P1  size: (int) P2];

		default :				NSLog(@"Unknown message passed to RAR callback function.");
			
		return STOP_PROCESSING;
	}
}


@implementation ExpanderItem

- intWithFileName:(NSString*)filename{
    self = [super init];
    if (self) {
		[self setFilePath:filename];
		[self setData:0];
		[self setCancleData:0];
		[self setPassWordContoller:0];
		[self setOneWindowControl:0];
		[self setWaitWindow:0];
		[self setSaveFilename:nil];
		[self setPasswords:nil];
		[self setMyPassword:nil];
		[self setBadAchive:0];
		[self setPasswordError:0];
			//[self setControlernum:0];
		[self setShowname:filename];
		[self setStates:@"Extract now"];
		[self setProgress:0.0];
		cursize = 0;
		
    }
		//[self startExpander];
	
    return self;
}

-(void)setPasswordError:(NSInteger)num
{
	passworderror = num;
}

-(NSInteger)passwordError
{
	return passworderror;
}

-(void)setBadAchive:(NSInteger)num
{
	badachive = num;
}

-(NSInteger)badAchive
{
	return badachive;
}

-(void)setExtractResult:(NSInteger)num
{
	extractresult = num;
}

-(NSInteger)ExtractResult
{
	return extractresult;
}

-(void)setSaveFilename:(NSString *)filename
{
	[filename retain];
	
	[savefilename release];
	
	savefilename = filename;
}

-(NSString *)saveFilename
{
	return savefilename;
}

-(void)setOneWindowControl:(NSInteger)num
{
	contorllornum = num; 
}

-(NSInteger)oneWindowControl
{
	return contorllornum;
}

-(void)setWaitWindow:(NSInteger)num
{
	windowsetnum = num;
}

-(NSInteger)waitWindow
{
	return windowsetnum;
}

-(void)setCancleData:(NSInteger)data
{
	canclenum = data;
}

-(NSInteger)cancleData
{
	return canclenum;
}


/*-(void)setProgressData:(NSInteger)num
{
	progressdata = num;
}

-(NSInteger)ProgressData
{
	return progressdata;
}*/

-(void)setControlernum:(NSInteger)num
{
	controlcanclenum = num;
}

-(NSInteger)controllerNum
{
	return controlcanclenum;
}

-(NSInteger)Data
{
	return datas;
}
-(void)setData:(NSInteger)number
{
	extern int datas;
	datas = number;
}

-(NSString*)showStates
{
	return states;
}

-(void)setStates:(NSString*)state
{
	
	[state retain];
	
	[states release];
	
	states = state;
}

-(void)setFilePath:(NSString*)paths
{
	[paths retain];
	
	[filepath release];
	
	filepath = paths;
}

- (NSString*)Showname{
	
	return fileanme;
}
- (void)setShowname:(NSString*)value{
	
	NSString *file = [value lastPathComponent];
	
	[file retain];
	
	[fileanme release];
	
	fileanme =file;
}

- (float)Progress{
	
	return nProgress;
}
- (void)setProgress:(float)value{
	
	nProgress = value;
}

- (void)expanderThread:(id)unusedObject {
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
		
    [self expanderContentEx];
	
    [pool release];
}

/*- (void)startExpander{
	
	[NSThread detachNewThreadSelector:@selector(expanderThread:) toTarget:self withObject:nil];
}
- (void) startExpanding: (id<ExpansionProcessProtocol>) expansionProcess_
{
	expansionProcess                            = expansionProcess_;
	[NSThread detachNewThreadSelector:@selector(expanderThread:) toTarget:self withObject:nil];
}*/

/*- (void) startExpanding: (ExpanderControl *) expansionProcess_
{
	expansionProcess                            = expansionProcess_;
	[NSThread detachNewThreadSelector:@selector(expanderThread:) toTarget:self withObject:nil];
}*/
-(void)startExpander:(ExpanderControl *)control
{
	expansionProcess                            = control;
	[NSThread detachNewThreadSelector:@selector(expanderThread:) toTarget:self withObject:nil];
}

-(void)setPassWordContoller:(NSInteger)passnum
{
	passwordcontoller = passnum;
}

-(NSInteger)passWordContoller
{
	return passwordcontoller;
}

-(void)setPasswords:(NSString*)pass
{
	
		//[pass retain];
	
	extern NSString* passd;
	
	passd = pass ;
	
	
}

/*-(void)setsavePassd:(char*)pass
{
	savepassd = pass;
}

-(char*)Passd;
{
	return passd;
}*/

-(void)setMyPassword:(NSString *)pass
{
	[pass retain];
	
	[password release];
	
	password= pass;
	
	
}

-(NSString*)passWord
{
	return password;
}

/*-(void)setExpansionControl:(ExpanderControl*)control
{
	if (expansionControl != control) {
		
        id old = expansionControl;
		
       expansionControl = [control retain];
		
        [old release];
		
	}
}*/

-(int) processOpenArchiveStatusCode: (int) statusCode handle: (HANDLE) archiveHandle
	//int processOpenArchiveStatusCode: (int statusCode,HANDLE archiveHandle)
{
		//NSLog(@"statuscode = %d",statusCode);
	switch (statusCode) {
			
		
		case ERAR_BAD_ARCHIVE : return -1;
				
		default               : NSLog(@"achive");
	}
	
}


- (struct RAROpenArchiveData) getOpenArchiveDataForMode: (int) mode
{
	struct RAROpenArchiveData archiveData;
	archiveData.OpenMode   = mode;
	archiveData.ArcName    = [filepath UTF8String];
	archiveData.CmtBuf     = NULL;
	archiveData.CmtBufSize = 0;
	archiveData.CmtSize    = 0;
	archiveData.CmtState   = 0;
	archiveData.OpenResult = 0;
	return archiveData;
}

-(BOOL)expanderContentEx{
	
	struct RARHeaderDataEx fileHeader;
	
	int result; HANDLE archive; 
	
	unsigned long long sizeSoFar;
	
		//struct RAROpenArchiveData archiveData = [self getOpenArchiveDataForMode: RAR_OM_LIST];
	
	struct RAROpenArchiveData archiveData = [self getOpenArchiveDataForMode: RAR_OM_LIST];
	
	fileHeader.CmtBuf = NULL;
	
	archive = RAROpenArchive(&archiveData);
	if ([self processOpenArchiveStatusCode: archiveData.OpenResult handle: archive] == -1)
	{
		[expansionProcess setBadAchive:-1];
		RARCloseArchive(archive);
		return 0;
	}

		
		
		//[NSApp runModalForWindow:[[NSApp delegate] w]];
		//[NSApp runModalForWindow:[expansionProcess passwordWindow]];
		//[expansionProcess passwordWindow];
		//NSString *str = @"1234";
	
		//char * str1 = [str UTF8String];
		//RARSetPassword(archive,str1);
	int i = 1;
	
	NSString* path = [filepath stringByDeletingPathExtension];
	
	while ([[NSFileManager defaultManager] fileExistsAtPath: path])
		
		path = [NSString stringWithFormat:@"%@%d",[filepath stringByDeletingPathExtension],i++];
	
	[[NSFileManager defaultManager] createDirectoryAtPath: path attributes: nil];
	
		//1[path retain];
	[self setSaveFilename:path];
	
	char outpath[512];
	strcpy(outpath,[path UTF8String]);
	
	
	sizeSoFar = 0;
	RARSetCallback(archive, handleRARCallBack, (long) self); // TODO: Is it ok to cast the object pointer to a long??
		
		// TODO: The compiler complains without the cast of &fileHeader ?
	
	while(((result = RARReadHeaderEx(archive, (struct RARHeaderDataEx *) &fileHeader)) == SUCCESS) ) { 

		if(RARProcessFile(archive, RAR_SKIP, NULL, NULL) != SUCCESS) {
				//[expansionProcess setWaitWindow:0];
				//RARSetCallback(archive, handleRARCallBack, (long) self);
								
				RARCloseArchive(archive);
			
				return NO;
		}
				
			if(!(fileHeader.Flags & FLAG_CONTINUATION)) {
				
			sizeSoFar += (unsigned long long) fileHeader.UnpSize +
				
			(((unsigned long long) fileHeader.UnpSizeHigh) << BITS_TO_SHIFT_HIGH_SIZE);
			}
	}
		
		//[self setExtractResult:result];
		//[expansionProcess setWaitWindow:0];
		//RARSetCallback(archive, handleRARCallBack, (long) self);
	totalSize = sizeSoFar;
	RARCloseArchive(archive);
	
	
	
	archiveData = [self getOpenArchiveDataForMode: RAR_OM_EXTRACT];
	
	fileHeader.CmtBuf = NULL;
		//result =0;
	
	archive = RAROpenArchive(&archiveData);
	
	if (archive == NULL)
	{
		return NO;
	}
		//RARSetPassword(archive,str1);
	
		//RARSetProcessDataProc(archive, processData);

		//sizeSoFar = 0;
	
		//NSLog(@"totlsize %d",totalSize);
	/*if ([self passWordContoller] == 1) {
		RARSetPassword(archive, [self passWord]);
		
	}*/
		//NSLog(@"callback");
	RARSetCallback(archive, handleRARCallBack, (long) self);
		//NSLog(@"call--back");
	// TODO: Is it ok to cast the object pointer to a long??
	
	/*if ([self passWord] == nil) {
		[[NSFileManager defaultManager] isDeletableFileAtPath: path];
		return YES;
	}*/
	
		//RARSetCallback(archive, handleRARCallBack, (long) self);
	
	
	
	// TODO: The compiler complains without the cast of &fileHeader ??
	while((result = RARReadHeaderEx(archive, (struct RARHeaderDataEx *) &fileHeader)) == SUCCESS) {
	
		if(RARProcessFile(archive, RAR_EXTRACT, outpath, NULL) != SUCCESS) {
			
			[expansionProcess setPasswordError:-1];
				RARCloseArchive(archive);
			
				return NO;
			
		}
		
	}
	
		//[expansionProcess setWaitWindow:0];
		//RARSetCallback(archive, handleRARCallBack, (long) self);
	
	RARCloseArchive(archive);
	
	[self setStates:@"Extract over"];
	
	return YES;
}
- (BOOL)expanderContent{
	
	/*struct RAROpenArchiveData testarchive;
	struct RARHeaderData header;
	HANDLE archive;
	int result;
	
	testarchive.OpenMode   = RAR_EXTRACT;
	char name[512];
	strcpy(name, [fileanme UTF8String]);
	testarchive.ArcName    = name;
	testarchive.CmtBuf     = NULL;
	testarchive.CmtBufSize = 0;
	
	header.CmtBuf = NULL;
	
	archive = RAROpenArchive(&testarchive);
	
	NSLog(@"OpenResult = %i\n", testarchive.OpenResult);
	
	RARSetChangeVolProc(archive, volumeChange);
	RARSetProcessDataProc(archive, processData);
	
	//RARReadHeader(archive, &header);
	
	//fprintf(stderr, "Filename = %s\n", header.FileName);
	
	//result = RARProcessFile(archive, RAR_EXTRACT, "/Users/ok/Desktop", NULL);
	unsigned long long sizeSoFar = 0;
	NSString* path = [fileanme stringByDeletingLastPathComponent];
	char outpath[512];
	strcpy(outpath, [path UTF8String]);
	while((result = RARReadHeader(archive, &header)) == 0) { 
		if(RARProcessFile(archive, RAR_EXTRACT, outpath, NULL) != 0) {
			//	[expansionProcess setTotalExpandedSizeUnknown];
			RARCloseArchive(archive);
			return NO;
		}
		
		if(!(header.Flags & FLAG_CONTINUATION)) {
			sizeSoFar += (unsigned long long) header.UnpSize +
			(((unsigned long long) fileHeader.UnpSizeHigh) << BITS_TO_SHIFT_HIGH_SIZE);
		}
	}

	
/*	while((result = RARReadHeaderEx(archive, (struct RARHeaderDataEx *) &header)) == SUCCESS) { 
		if(RARProcessFile(archive, RAR_SKIP, NULL, NULL) != SUCCESS) {
			[expansionProcess setTotalExpandedSizeUnknown];
			RARCloseArchive(archive);
			return;
		}
		
		if(!(fileHeader.Flags & FLAG_CONTINUATION)) {
			sizeSoFar += (unsigned long long) fileHeader.UnpSize +
			(((unsigned long long) fileHeader.UnpSizeHigh) << BITS_TO_SHIFT_HIGH_SIZE);
		}
	}*/
	

	return YES;
}


- (int) handleProcessDataCallBack:  (unsigned char *) data  size: (int) size
{
		//NSLog(@"size = %d",size);
	if ([self cancleData] == -1) {
		
		return -1;
		
	}
		//NSLog(@"cancledata = %@",[self cancleData]);
	cursize+= size;
	
	CGFloat f = (cursize*1.0f /totalSize)*100;
	
		//NSLog(@"nprogress = %f",f);
	[self setProgress:f];
	
	return CONTINUE_PROCESSING;
	
}

- (int) handleNeedPasswordCallBack: (char *) data size: (int) size
{
	
	NSInteger windowcontrolnum = [expansionProcess oneWindowControl];
	NSInteger mcontrolnumber = [expansionProcess controllerNum];
	
	if(windowcontrolnum == 1){
		if (mcontrolnumber == 1) {
			[self setStates:@"Extract over"];
			
			return STOP_PROCESSING;

		}
		
		strcpy(data, [[self passWord] UTF8String]);
		return CONTINUE_PROCESSING;
	}
		
	
	if (windowcontrolnum == 0) {
		
		[expansionProcess setOneWindowControl:1];
		
		[expansionProcess runPasswordWindow];
			
		NSInteger waitnum = [expansionProcess waitWindow];
	while (waitnum == 0) {
			
		
			NSInteger waitWindowNum = [expansionProcess waitWindow];
			NSInteger controlnumber = [expansionProcess controllerNum];
		if (controlnumber == 1) {
			[self setStates:@"Extract over"];
			return STOP_PROCESSING;
				//return 0;
		}
		
		if (waitWindowNum == 1) {
				//NSLog(@"self result = %@",[self ExtractResult]);
			
				if ([passd length] < 1) {
						//NSLog(@"passd = %@",passd);
				
					[expansionProcess setControlernum:1];
						[self setStates:@"Extract over"];
					return STOP_PROCESSING;
				}
					/*[expansionProcess setWaitWindow:0];
				
				[expansionProcess runPasswordWindow];
		
				NSInteger waitnum = [expansionProcess waitWindow];
				while (waitnum == 0) {					
					NSInteger waitWindowNum = [expansionProcess waitWindow];
					NSInteger controlnumber = [self controllerNum];
					if (controlnumber == 1) {
						[self setStates:@"Extract over"];
						return STOP_PROCESSING;
					}
					
					if (waitWindowNum == 1) {
						
						NSLog(@"self result-1 = %@",[self ExtractResult]);
						NSLog(@"passd-1 = %@",passd);
						if ([self ExtractResult] == 1) {
							
								[expansionProcess setControlernum:1];
								[self setStates:@"Extract over"];
							return STOP_PROCESSING;
								//[[NSFileManager defaultManager] isDeletableFileAtPath:[self saveFilename]];
						}
						
						const char * passwordAsCString = [passd UTF8String];
						
						strcpy(data, passwordAsCString);
						NSString *str = [[NSString alloc] initWithUTF8String:data];
						[self setMyPassword:str];
							
						return CONTINUE_PROCESSING;
					} 
				}*/
			
			
			
					//return CONTINUE_PROCESSING;
					//}
			
		const char * passwordAsCString = [passd UTF8String];
			
				//if (strlen(passwordAsCString) < size) {
			strcpy(data, passwordAsCString);
			NSString *str = [[NSString alloc] initWithUTF8String:data];
			[self setMyPassword:str];
				
			return CONTINUE_PROCESSING;
		} 
	}
	}

	return CONTINUE_PROCESSING;
	
}

@end
