/*

The dll.hpp (naturally) relies on a few macro's and type definitions used
in the Windows API. I have defined these here for compatibility. When 
updating to a new version of unrar make sure that this file is included from
within dll.hpp 

*/

#define CALLBACK
#define PASCAL

typedef void * HANDLE;
typedef unsigned long LONG;
typedef unsigned int UINT;

#define BITS_TO_SHIFT_HIGH_SIZE 32

#define STOP_PROCESSING     -1
#define CONTINUE_PROCESSING  1
#define SUCCESS              0

// FLAG_CONTINUATION -> RAR file is continued from previous volume
#define FLAG_CONTINUATION  0x01 


