//
//  mainView.m
//  RARExpander
//
//  Created by KO on 11-3-30.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//
#define BORDER_CORNER_RADIUS    4.0

#define CONST_HEIGHT            70

#import "mainView.h"
#import "ExpanderControl.h"
#import "ExpanderItem.h"
#import "AppController.h"


@implementation mainView

- (void)dealloc {
	[nodes release];
    [super dealloc];
}

-(void)awakeFromNib{
	
	nodes = [[NSMutableArray alloc] init];
}

/*- (void) setExpander: (id) anObject
{
	NSLog(@"Expander announced itself.");
    [anObject setProtocolForProxy:@protocol(ExpanderPublicProtocol)];
    expander = (id <ExpanderPublicProtocol>)[anObject retain];
		//[self tellExpanderToStartOnNext];
    return;
}*/

- (void)addItem:(NSString*)name{
	
	
	ExpanderItem* item = [[ExpanderItem alloc] intWithFileName:name];
	
		
	ExpanderControl *itemView = [[ExpanderControl alloc] init];
	
		//AppController *appcontrowindow = [[AppController alloc] init];
	
	
	[itemView setItem:item];
	
		//[item setExpansionControl:itemView];
	
	NSRect rect = NSMakeRect(BORDER_CORNER_RADIUS, [self bounds].size.height , [self bounds].size.width, CONST_HEIGHT );
	
	[[itemView rootView] setFrame:rect];
		
	/*while ([item controllerNum] !=1) {
		
			if([item controllerNum] ==1)
			{
		
		[appcontrowindow runPasswordWindow];*/
		
	[nodes addObject:itemView];
	
	[item startExpander:itemView];
	
		// serverObject = [[self alloc] init];
		//[(id)[serverConnection rootProxy] setExpander:item];
		//[item release];
	
		//[[NSRunLoop currentRunLoop] run];
	
		//[[nodes lastObject] setProtocolForProxy:@protocol(ExpanderPublicProtocol)];
		/*expander = (id <ExpanderPublicProtocol>)[item retain];
		[item release];
	[expander startExpanding: [nodes lastObject]];*/
		//[expander startExpanding: itemView];
	

		
	[self addSubview:[itemView rootView]];
		
	[itemView setProgress];
		
	[self layoutSubviews:[itemView rootView]];

	[NSThread detachNewThreadSelector:@selector(remove:) toTarget:self withObject:[itemView rootView]];
		//[self remove:[itemView rootView]];
			
		
}
	 
-(void)layoutSubviews:(NSView*)item
{

	NSInteger index = [[self subviews] indexOfObject:item];
	
	NSInteger totalH = (index + 1 ) * ([item bounds].size.height);
	
	[[NSApp delegate]setWindowsHeight:totalH];
    
	if (totalH > [[self superview] frame].size.height)
		[self setFrameSize:NSMakeSize([self bounds].size.width, totalH)];
	else
		[self setFrameSize:NSMakeSize([self bounds].size.width, [[self superview] frame].size.height)];
	
	NSInteger y = ([self bounds].size.height - totalH);
	
	[item setFrameOrigin:NSMakePoint(BORDER_CORNER_RADIUS, y)];

	
}

-(void)remove:(NSView *)items{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
		
	
	while (nodes.count != 0) {
		NSInteger i = [[self subviews] indexOfObject:items];
		
		[self removeItem:items index:i];
			
			}
	[pool release];

}

-(void)removeItem:(NSView *)items index:(NSInteger)i;
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
		
	@synchronized(self)
	{
	[self removeItemByIndex:i view:items];
	}
	
	[pool release];
}

-(void)removeItemByIndex:(NSInteger)index view:(NSView *)item
{
		
	if(index < nodes.count)
	{
		ExpanderControl* node = [nodes objectAtIndex:index];
	
		int j = [node getProgress];
		
		NSString *str = @"Extract over";
			
		NSString *str1 = [node checkStates];
		
		NSInteger l = [[node item] controllerNum];
		
		NSInteger d = [[node item] cancleData];
		
		NSInteger badachivecanclenum = [[node item] badAchive];
		
		NSInteger passworderrornum = [[node item] passwordError];
	
		if ( j == 100 || str1 == str ||(l==1 && str == str1) || d== -1 || badachivecanclenum == -1 || passworderrornum == -1) 
		{
		
			[item removeFromSuperview];
		
			[nodes removeObjectAtIndex:index];
						
			NSInteger number = nodes.count;
			
			NSInteger totalH;
			
			totalH = (number) * ([item bounds].size.height);
			
			if((index < number)&&(index>0))
			{
				
				for(NSInteger i=index ; i<number ; i++)
				{
					
					if(number >= 1)
					{
						totalH = (number) * ([item bounds].size.height);
					}
					
					[[NSApp delegate]setWindowsHeight:totalH];
					
					ExpanderControl* nod = [nodes objectAtIndex:i];
				
					if (totalH > [[self superview] frame].size.height)
						
						[self setFrameSize:NSMakeSize([self bounds].size.width, totalH)];
					else
						
						[self setFrameSize:NSMakeSize([self bounds].size.width, [[self superview] frame].size.height)];
				
					NSInteger k = (number -i- 1)*[[nod rootView] bounds].size.height;
					
					NSInteger y = [self bounds].size.height - totalH + k;
				
					[[nod rootView] setFrameOrigin:NSMakePoint(BORDER_CORNER_RADIUS, y)];
				
					[self setNeedsDisplay:YES];
				}
			
			}
			
			if((index < number)&&(index==0))
			{
			
				for(NSInteger i=0 ; i<number ; i++)
				{
					
					if(number >= 1)
					{
						totalH = (number) * ([item bounds].size.height);
					}
						
					[[NSApp delegate]setWindowsHeight:totalH];
					
					ExpanderControl* nod = [nodes objectAtIndex:i];
									
					if (totalH > [[self superview] frame].size.height)
						
						[self setFrameSize:NSMakeSize([self bounds].size.width, totalH)];
					else
						
						[self setFrameSize:NSMakeSize([self bounds].size.width, [[self superview] frame].size.height)];
					 
					NSInteger k = (number -i- 1)*[[nod rootView] bounds].size.height;
					
					NSInteger y = [self bounds].size.height - totalH + k;
				
					[[nod rootView] setFrameOrigin:NSMakePoint(BORDER_CORNER_RADIUS, y)];
						
					[self setNeedsDisplay:YES];
					
				}
			
			}
			
			[[NSApp delegate]setWindowsHeight:totalH];
		
			[self setNeedsDisplay:YES];
		
			if (nodes.count == 0 && (j == 100 || str1 == str || l == 1 || d == -1 || badachivecanclenum == -1 || passworderrornum == -1)) 
			{
			
				[NSApp terminate:self];
				
			}
	
		}
			
	}


}	
			
/*-(void)updateItemIndex:(NSView *)item
{
		//ExpanderControl* node = [nodes objectAtIndex:index];
		//NSView *item = [node rootView];
	NSInteger index = [[self subviews] indexOfObject:item];
	NSInteger number = nodes.count;
	
	NSInteger totalH;
	totalH = (number) * ([item bounds].size.height);
		//[[NSApp delegate]setWindowsHeight:totalH];
		if((index) < number)
		{
	for(NSInteger i=index+1 ; i<number ; i++)
	{
			//number = nodes.count; 

			//NSInteger totalH;
		
		if(number >= 1)
		{
			 totalH = (number) * ([item bounds].size.height);
		}
			//if(number > 1) 
			//	{
			//	 totalH = (number -1) * ([item bounds].size.height);
			//	}
		ExpanderControl* nod = [nodes objectAtIndex:i];
		
		if (totalH > [[self superview] frame].size.height)
			[self setFrameSize:NSMakeSize([self bounds].size.width, totalH)];
		else
			[self setFrameSize:NSMakeSize([self bounds].size.width, [[self superview] frame].size.height)];
		
		NSInteger y = [self bounds].size.height - totalH;
		
		[[nod rootView] setFrameOrigin:NSMakePoint(BORDER_CORNER_RADIUS, y)];
		
		
		[[NSApp delegate]setWindowsHeight:totalH];
			//[self setNeedsDisplay:YES];
	}
	
		}
	
	[[NSApp delegate]setWindowsHeight:totalH-1];
	
	[self setNeedsDisplay:YES];
	int j = [node getProgress];
	
	if (nodes.count == 0 && j == 100) {
		[[NSApp delegate] closeWindow];
	}
}*/

-(void)removeBtnItem:(NSView *)items
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	while([self checkNode] != 0)
	{
		for(NSInteger i=0;i<nodes.count;i++)
		{
			[self removeItemByBtn:i view:items];
			
		}
	}
	[pool release];
}

-(NSInteger)checkNode
{
	return nodes.count;
}

/*+(NSInteger)cNode
{
	return nodes.count;
}*/


-(void)removeItemByBtn:(NSInteger)index view:(NSView *)item
{
	ExpanderControl* node = [nodes objectAtIndex:index];
	
	NSInteger n = [node getData];
	
	if (n == 1){
	
		[[node rootView] removeFromSuperview];
		
		[nodes removeObjectAtIndex:index];
		
		NSInteger number = nodes.count;
		
		for(NSInteger i=index ; i<number ; i++)
		{
			NSInteger totalH;
			
			if(number >= 1)
			{
				totalH = (number) * ([item bounds].size.height);
			}
			/*if(number > 1) 
			 {
			 totalH = (number -1) * ([item bounds].size.height);
			 }*/
			
			[[NSApp delegate]setWindowsHeight:totalH];
			
			if (totalH > [[self superview] frame].size.height)
				[self setFrameSize:NSMakeSize([self bounds].size.width, totalH)];
			else
				[self setFrameSize:NSMakeSize([self bounds].size.width, [[self superview] frame].size.height)];
			
			NSInteger y = [self bounds].size.height - totalH;
			
			[item setFrameOrigin:NSMakePoint(BORDER_CORNER_RADIUS, y)];
			
		}
		
	[self setNeedsDisplay:YES];
		
	}
	
}

@end
